#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const ll MOD = 1e9+7;
const int N = 2e5+5;
const int LOG = 20;

int n,q,a[N],s[LOG][N];

int main(){
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    cin>>n>>q;

    for(int i=1;i<=n;i++){
        cin>>a[i];
        for(int j=0;j<LOG;j++){
            if((1<<j)&a[i]){
                s[j][i]=1;
            }
        }
    }

    for(int j=0;j<LOG;j++){
        for(int i=1;i<=n;i++)s[j][i]+=s[j][i-1];
    }

    int l,r;
    while(q--){
        cin>>l>>r;

        int ans=0;
        for(int j=0;j<LOG;j++){
            if(s[j][r]-s[j][l-1]==r-l+1)ans+=(1<<j);
        }
        cout<<ans<<"\n";
    }


    return 0;
}